Index: trunk/source/processes/hadronic/cross_sections/src/G4IonsKoxCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4IonsKoxCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4IonsKoxCrossSection.cc	(revision 1340)
@@ -32,13 +32,14 @@
 #include "G4ParticleTable.hh"
 #include "G4IonTable.hh"
+#include "G4HadTmpUtil.hh"
 
 G4double G4IonsKoxCrossSection::
-GetIsoZACrossSection(const G4DynamicParticle* aParticle, G4double ZZ, 
-                     G4double AA, G4double /*temperature*/)
+GetZandACrossSection(const G4DynamicParticle* aParticle, G4int ZZ, 
+                     G4int AA, G4double /*temperature*/)
 {
    G4double xsection = 0.0;
 
    G4int Ap = aParticle->GetDefinition()->GetBaryonNumber();
-   G4int Zp = int ( aParticle->GetDefinition()->GetPDGCharge() / eplus + 0.5); 
+   G4int Zp = G4int(aParticle->GetDefinition()->GetPDGCharge() / eplus + 0.5); 
    G4double ke_per_N = aParticle->GetKineticEnergy() / Ap;
 
@@ -46,6 +47,6 @@
    // if (  ke_per_N < lowerLimit ) return xsection;
 
-   G4int At = int (AA + 0.5);
-   G4int Zt = int (ZZ + 0.5 );  
+   G4int At = AA;
+   G4int Zt = ZZ;  
 
    G4double one_third = 1.0 / 3.0;
@@ -54,8 +55,10 @@
    G4double cubicrAp = std::pow ( G4double(Ap) , G4double(one_third) );  
 
+   // rc divide fermi
+   G4double Bc = Zt * Zp / ( (rc/fermi) * (cubicrAp+cubicrAt) );
 
-   G4double Bc = Zt * Zp / ( ( rc / fermi ) * (  cubicrAp + cubicrAt ) );   // rc divide fermi
-   G4double targ_mass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass( Zt , At ); 
-   G4double proj_mass = aParticle->GetMass(); 
+   G4double targ_mass =
+     G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass(Zt, At); 
+   G4double proj_mass = aParticle->GetMass();
    G4double proj_momentum = aParticle->GetMomentum().mag(); 
 
@@ -69,14 +72,14 @@
 
    G4double a = 1.85;
-   G4double Rsurf = r0 * ( a * cubicrAp * cubicrAt / ( cubicrAp + cubicrAt ) - c); 
+   G4double Rsurf = r0 * (a*cubicrAp * cubicrAt/(cubicrAp + cubicrAt) - c); 
    G4double D = 5.0 * ( At - 2 * Zt ) * Zp / ( Ap * At );
    Rsurf = Rsurf + D * fermi;  // multiply D by fermi 
 
    G4double Rint = Rvol + Rsurf;
-
    xsection = pi * Rint * Rint * ( 1 - Bc / ( Ecm / MeV ) );
   
    return xsection; 
 }
+
 
 G4double G4IonsKoxCrossSection::
@@ -91,18 +94,18 @@
     G4IsotopeVector* isoVector = anElement->GetIsotopeVector();
     G4double* abundVector = anElement->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
      
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
-      sig = GetIsoZACrossSection(aParticle, ZZ, AA, temperature);
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
+      sig = GetZandACrossSection(aParticle, ZZ, AA, temperature);
       xsection += sig*abundVector[i];
     }
    
   } else {
-    xsection =
-      GetIsoZACrossSection(aParticle, anElement->GetZ(), anElement->GetN(),
-                           temperature);
+    G4int ZZ = G4lrint(anElement->GetZ());
+    G4int AA = G4lrint(anElement->GetN());
+    xsection = GetIsoZACrossSection(aParticle, ZZ, AA, temperature);
   }
     
@@ -111,5 +114,6 @@
 
 
-G4double G4IonsKoxCrossSection::calEcm ( G4double mp , G4double mt , G4double Plab )
+G4double
+G4IonsKoxCrossSection::calEcm(G4double mp, G4double mt, G4double Plab)
 {
    G4double Elab = std::sqrt ( mp * mp + Plab * Plab );
@@ -121,5 +125,5 @@
 
 
-G4double G4IonsKoxCrossSection::calCeValue( const G4double ke )
+G4double G4IonsKoxCrossSection::calCeValue(const G4double ke)
 {
    // Calculate c value 
@@ -131,5 +135,5 @@
    G4double Ce; 
    G4double log10_ke = std::log10 ( ke );   
-   if ( log10_ke > 1.5 ) 
+   if (log10_ke > 1.5) 
    {
       Ce = - 10.0 / std::pow ( G4double(log10_ke) , G4double(5) ) + 2.0;
@@ -137,5 +141,6 @@
    else
    {
-      Ce = ( - 10.0 / std::pow ( G4double(1.5) , G4double(5) ) + 2.0 ) / std::pow ( G4double(1.5) , G4double(3) ) * std::pow ( G4double(log10_ke) , G4double(3) );
+      Ce = (-10.0/std::pow(G4double(1.5), G4double(5) ) + 2.0) /
+           std::pow(G4double(1.5), G4double(3)) * std::pow(G4double(log10_ke), G4double(3) );
 
    }
Index: trunk/source/processes/hadronic/cross_sections/src/G4IonsShenCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4IonsShenCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4IonsShenCrossSection.cc	(revision 1340)
@@ -33,14 +33,15 @@
 #include "G4ParticleTable.hh"
 #include "G4IonTable.hh"
+#include "G4HadTmpUtil.hh"
 
 
 G4double G4IonsShenCrossSection::
-GetIsoZACrossSection(const G4DynamicParticle* aParticle, G4double ZZ, 
-                G4double AA, G4double /*temperature*/)
+GetZandACrossSection(const G4DynamicParticle* aParticle, G4int ZZ, 
+                     G4int AA, G4double /*temperature*/)
 {
    G4double xsection = 0.0;
 
    G4int Ap = aParticle->GetDefinition()->GetBaryonNumber();
-   G4int Zp = int ( aParticle->GetDefinition()->GetPDGCharge() / eplus + 0.5 ); 
+   G4int Zp = G4int(aParticle->GetDefinition()->GetPDGCharge()/eplus + 0.5 ); 
    G4double ke_per_N = aParticle->GetKineticEnergy() / Ap; 
    if ( ke_per_N > 10*GeV ) ke_per_N = 10*GeV;
@@ -49,6 +50,6 @@
    // if (  ke_per_N < lowerLimit ) return xsection;
 
-   G4int At = G4int(AA);
-   G4int Zt = G4int(ZZ);
+   G4int At = AA;
+   G4int Zt = ZZ;
  
    G4double one_third = 1.0 / 3.0;
@@ -62,9 +63,10 @@
    G4double r = Rt + Rp + 3.2;   // in fm
    G4double b = 1.0;   // in MeV/fm
-   G4double targ_mass = G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass( Zt , At );
+   G4double targ_mass =
+     G4ParticleTable::GetParticleTable()->GetIonTable()->GetIonMass(Zt, At);
    G4double proj_mass = aParticle->GetMass();
    G4double proj_momentum = aParticle->GetMomentum().mag();
 
-   G4double Ecm = calEcmValue ( proj_mass , targ_mass , proj_momentum ); 
+   G4double Ecm = calEcmValue (proj_mass, targ_mass, proj_momentum); 
 
    G4double B = 1.44 * Zt * Zp / r - b * Rt * Rp / ( Rt + Rp ); 
@@ -74,16 +76,16 @@
    G4double c = calCeValue ( ke_per_N / MeV  );  
 
-   G4double R1 = r0 * ( cubicrAt + cubicrAp + 1.85 * cubicrAt * cubicrAp / ( cubicrAt + cubicrAp ) - c); 
+   G4double R1 = r0 * (cubicrAt + cubicrAp + 1.85*cubicrAt*cubicrAp/(cubicrAt + cubicrAp) - c); 
 
    G4double R2 = 1.0 * ( At - 2 * Zt ) * Zp / ( Ap * At );
 
 
-   G4double R3 = 0.176 / std::pow ( G4double(Ecm) , G4double(one_third) ) * cubicrAt * cubicrAp / ( cubicrAt + cubicrAp );
+   G4double R3 = 0.176 / std::pow(G4double(Ecm), G4double(one_third)) * cubicrAt * cubicrAp /(cubicrAt + cubicrAp);
 
    G4double R = R1 + R2 + R3;
 
    xsection = 10 * pi * R * R * ( 1 - B / Ecm );   
-   xsection = xsection * millibarn;   // mulitply xsection by millibarn    
-  
+   xsection = xsection * millibarn;   // mulitply xsection by millibarn
+
    return xsection; 
 }
@@ -101,10 +103,10 @@
     G4IsotopeVector* isoVector = anElement->GetIsotopeVector();
     G4double* abundVector = anElement->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
    
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
       sig = GetIsoZACrossSection(aParticle, ZZ, AA, temperature);
       xsection += sig*abundVector[i];
@@ -112,7 +114,7 @@
  
   } else {
-    xsection =
-      GetIsoZACrossSection(aParticle, anElement->GetZ(), anElement->GetN(), 
-                           temperature);
+    G4int ZZ = G4lrint(anElement->GetZ());
+    G4int AA = G4lrint(anElement->GetN());
+    xsection = GetIsoZACrossSection(aParticle, ZZ, AA, temperature);
   }
   
@@ -121,5 +123,7 @@
 
 
-G4double G4IonsShenCrossSection::calEcmValue( const G4double mp , const G4double mt , const G4double Plab )
+G4double
+G4IonsShenCrossSection::calEcmValue(const G4double mp, const G4double mt,
+                                    const G4double Plab)
 {
    G4double Elab = std::sqrt ( mp * mp + Plab * Plab );
@@ -131,21 +135,23 @@
 
 
-G4double G4IonsShenCrossSection::calCeValue( const G4double ke )
+G4double G4IonsShenCrossSection::calCeValue(const G4double ke)
 {
-   // Calculate c value 
-   // This value is indepenent from projectile and target particle 
-   // ke is projectile kinetic energy per nucleon in the Lab system with MeV unit 
-   // fitting function is made by T. Koi 
-   // There are no data below 30 MeV/n in Kox et al., 
+  // Calculate c value 
+  // This value is indepenent from projectile and target particle 
+  // ke is projectile kinetic energy per nucleon in the Lab system 
+  // with MeV unit 
+  // fitting function is made by T. Koi 
+  // There are no data below 30 MeV/n in Kox et al., 
 
    G4double Ce; 
    G4double log10_ke = std::log10 ( ke );   
-   if ( log10_ke > 1.5 ) 
+   if (log10_ke > 1.5) 
    {
-      Ce = - 10.0 / std::pow ( G4double(log10_ke) , G4double(5) ) + 2.0;
+     Ce = -10.0/std::pow(G4double(log10_ke), G4double(5)) + 2.0;
    }
    else
    {
-      Ce = ( - 10.0 / std::pow ( G4double(1.5) , G4double(5) ) + 2.0 ) / std::pow ( G4double(1.5) , G4double(3) ) * std::pow ( G4double(log10_ke) , G4double(3) );
+     Ce = (-10.0/std::pow(G4double(1.5), G4double(5) ) + 2.0) /
+         std::pow(G4double(1.5) , G4double(3)) * std::pow(G4double(log10_ke), G4double(3));
    }
    return Ce;
Index: trunk/source/processes/hadronic/cross_sections/src/G4IonsSihverCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4IonsSihverCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4IonsSihverCrossSection.cc	(revision 1340)
@@ -31,16 +31,14 @@
 #include "G4ParticleTable.hh"
 #include "G4IonTable.hh"
+#include "G4HadTmpUtil.hh"
 
 G4double G4IonsSihverCrossSection::
-GetIsoZACrossSection(const G4DynamicParticle* aParticle, G4double /*ZZ*/, 
-                G4double AA, G4double /*aTemperature*/)
+GetZandACrossSection(const G4DynamicParticle* aParticle,
+                     G4int /*ZZ*/, G4int AA, G4double /*aTemperature*/)
 {
    G4double xsection = 0.0;
-
-   G4int At = G4int(AA);
-   //G4int Zt = G4int(ZZ);  // not used 
+   G4int At = AA;
 
    G4int Ap = aParticle->GetDefinition()->GetBaryonNumber();
-   //Zp = aParticle->GetDefinition()->GetPDGCharge();   // not used  
  
    G4double one_third = 1.0 / 3.0;
@@ -49,8 +47,8 @@
    G4double cubicrAp = std::pow ( G4double(Ap) , G4double(one_third) );  
 
-   G4double b0 = 1.581 - 0.876 * ( 1.0 / cubicrAp + 1.0 / cubicrAt );
+   G4double b0 = 1.581 - 0.876 * (1.0/cubicrAp + 1.0/cubicrAt);
 
    xsection = pi * square_r0 
-            * std::pow ( G4double(cubicrAp + cubicrAt - b0 * (  1.0 / cubicrAp + 1.0 / cubicrAt ) ), G4double(2) );
+            * std::pow(G4double(cubicrAp + cubicrAt - b0 * (1.0/cubicrAp + 1.0/cubicrAt)), G4double(2));
   
    return xsection; 
@@ -69,10 +67,10 @@
     G4IsotopeVector* isoVector = anElement->GetIsotopeVector();
     G4double* abundVector = anElement->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
     
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
       sig = GetIsoZACrossSection(aParticle, ZZ, AA, temperature);
       xsection += sig*abundVector[i];
@@ -80,7 +78,7 @@
   
   } else {
-    xsection =
-      GetIsoZACrossSection(aParticle, anElement->GetZ(), anElement->GetN(),
-                           temperature);
+    G4int ZZ = G4lrint(anElement->GetZ());
+    G4int AA = G4lrint(anElement->GetN());
+    xsection = GetIsoZACrossSection(aParticle, ZZ, AA, temperature);
   }
    
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronCaptureXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronCaptureXS.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronCaptureXS.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NeutronCaptureXS.cc,v 1.3 2010/06/03 11:50:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NeutronCaptureXS.cc,v 1.5 2010/10/15 22:36:13 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -48,14 +48,16 @@
 #include <fstream>
 #include <sstream>
+
 using namespace std;
 
 G4NeutronCaptureXS::G4NeutronCaptureXS() 
+  : emax(20*MeV),maxZ(92)
 {
-  verboseLevel = 0;
-  emax = 20.*MeV;
-  G4cout  << "G4NeutronCaptureXS::G4NeutronCaptureXS: Initialise " << G4endl;
-  for(G4int i=0; i<93; ++i) {
-    data[i] = 0;
+  //  verboseLevel = 0;
+  if(verboseLevel > 0){
+    G4cout  << "G4NeutronCaptureXS::G4NeutronCaptureXS: Initialise for Z < "
+	    << maxZ + 1 << G4endl;
   }
+  data.resize(maxZ+1, 0);
   isInitialized = false;
 }
@@ -63,5 +65,5 @@
 G4NeutronCaptureXS::~G4NeutronCaptureXS()
 {
-  for(G4int i=0; i<92; ++i) {
+  for(G4int i=0; i<=maxZ; ++i) {
     delete data[i];
   }
@@ -76,6 +78,6 @@
 
 G4bool 
-G4NeutronCaptureXS::IsZAApplicable(const G4DynamicParticle*,
-				      G4double /*ZZ*/, G4double /*AA*/)
+G4NeutronCaptureXS::IsIsoApplicable(const G4DynamicParticle*,
+				    G4int /*ZZ*/, G4int /*AA*/)
 {
   return false;
@@ -90,5 +92,5 @@
   G4double xs = 0.0;
   G4double ekin = aParticle->GetKineticEnergy();
-  if(ekin > emax) return xs;
+  if(ekin > emax) { return xs; }
 
   G4int Z = G4int(elm->GetZ());
@@ -99,5 +101,5 @@
     Initialise(Z);
     pv = data[Z];
-    if(!pv) return xs;
+    if(!pv) { return xs; }
   }
 
@@ -118,10 +120,9 @@
 G4NeutronCaptureXS::BuildPhysicsTable(const G4ParticleDefinition& p)
 {
-  G4cout << "G4NeutronCaptureXS::BuildPhysicsTable: " << G4endl;
-  G4cout << p.GetParticleName() << G4endl;
-  if(p.GetParticleName() != "neutron") {
-    return;
+  if(verboseLevel > 0){
+    G4cout << "G4NeutronCaptureXS::BuildPhysicsTable for " 
+	   << p.GetParticleName() << G4endl;
   }
-  if(isInitialized) return;
+  if(isInitialized || p.GetParticleName() != "neutron") { return; }
   isInitialized = true;
 
@@ -140,6 +141,6 @@
     for(size_t i=0; i<numOfElm; ++i) {
       G4int Z = G4int(((*theElmTable)[i])->GetZ());
-      if(Z < 1) Z = 1;
-      else if(Z > 92) Z = 92;
+      if(Z < 1)         { Z = 1; }
+      else if(Z > maxZ) { Z = maxZ; }
       //G4cout << "Z= " << Z << G4endl;
       // Initialisation 
@@ -151,11 +152,11 @@
 void 
 G4NeutronCaptureXS::DumpPhysicsTable(const G4ParticleDefinition&)
-{
-}
+{}
+
 
 void 
 G4NeutronCaptureXS::Initialise(G4int Z, const char* p)
 {
-  if(data[Z]) return;
+  if(data[Z]) { return; }
   const char* path = p;
   if(!p) {
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronElasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronElasticXS.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronElasticXS.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NeutronElasticXS.cc,v 1.4 2010/06/03 11:50:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NeutronElasticXS.cc,v 1.6 2010/10/15 22:35:58 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -47,20 +47,26 @@
 #include "G4PhysicsVector.hh"
 #include "G4GlauberGribovCrossSection.hh"
+#include "G4HadronNucleonXsc.hh"
 #include "G4NistManager.hh"
+#include "G4Proton.hh"
 
 #include <iostream>
 #include <fstream>
 #include <sstream>
+
 using namespace std;
 
 G4NeutronElasticXS::G4NeutronElasticXS() 
-{
-  verboseLevel = 0;
-  G4cout  << "G4NeutronElasticXS::G4NeutronElasticXS: Initialise " << G4endl;
-  for(G4int i=0; i<93; ++i) {
-    data[i] = 0;
-    coeff[i]= 1.0;
-  }
+  :  proton(G4Proton::Proton()), maxZ(92)
+{
+  //  verboseLevel = 0;
+  if(verboseLevel > 0){
+    G4cout  << "G4NeutronElasticXS::G4NeutronElasticXS Initialise for Z < " 
+	    << maxZ + 1 << G4endl;
+  }
+  data.resize(maxZ+1, 0);
+  coeff.resize(maxZ+1, 1.0);
   ggXsection = new G4GlauberGribovCrossSection();
+  fNucleon = new G4HadronNucleonXsc();
   isInitialized = false;
 }
@@ -68,5 +74,5 @@
 G4NeutronElasticXS::~G4NeutronElasticXS()
 {
-  for(G4int i=0; i<92; ++i) {
+  for(G4int i=0; i<=maxZ; ++i) {
     delete data[i];
   }
@@ -75,5 +81,5 @@
 G4bool 
 G4NeutronElasticXS::IsApplicable(const G4DynamicParticle*, 
-				   const G4Element*)
+				 const G4Element*)
 {
   return true;
@@ -81,15 +87,13 @@
 
 G4bool 
-G4NeutronElasticXS::IsZAApplicable(const G4DynamicParticle*,
-				     G4double /*ZZ*/, G4double /*AA*/)
+G4NeutronElasticXS::IsIsoApplicable(const G4DynamicParticle*,
+                                    G4int /*ZZ*/, G4int /*AA*/)
 {
   return false;
 }
-
 
 G4double 
 G4NeutronElasticXS::GetCrossSection(const G4DynamicParticle* aParticle,
-				      const G4Element* elm,
-				      G4double)
+				    const G4Element* elm, G4double)
 {
   G4double xs = 0.0;
@@ -97,4 +101,5 @@
 
   G4int Z = G4int(elm->GetZ());
+  if(Z < 1 || Z > maxZ) { return xs; }
   G4PhysicsVector* pv = data[Z];
   //  G4cout  << "G4NeutronElasticXS::GetCrossSection e= " << ekin << " Z= " << Z << G4endl;
@@ -104,14 +109,18 @@
     Initialise(Z);
     pv = data[Z];
-    if(!pv) return xs;
+    if(!pv) { return xs; }
   }
 
   G4double e1 = pv->Energy(0);
-  if(ekin <= e1) return (*pv)[0];
+  if(ekin <= e1) { return (*pv)[0]; }
 
   G4int n = pv->GetVectorLength() - 1;
   G4double e2 = pv->Energy(n);
+
   if(ekin <= e2) { 
     xs = pv->Value(ekin); 
+  } else if(1 == Z) { 
+    fNucleon->GetHadronNucleonXscPDG(aParticle, proton);
+    xs = coeff[1]*fNucleon->GetElasticHadronNucleonXsc();
   } else {          
     ggXsection->GetCrossSection(aParticle, elm);
@@ -129,12 +138,10 @@
 G4NeutronElasticXS::BuildPhysicsTable(const G4ParticleDefinition& p)
 {
-  G4cout << "G4NeutronElasticXS::BuildPhysicsTable: " << G4endl;
-  G4cout << p.GetParticleName() << G4endl;
-  if(p.GetParticleName() != "neutron") {
-    return;
-  }
-  if(isInitialized) return;
+  if(verboseLevel > 0){
+    G4cout << "G4NeutronElasticXS::BuildPhysicsTable for " 
+	   << p.GetParticleName() << G4endl;
+  }
+  if(isInitialized || p.GetParticleName() != "neutron") { return; }
   isInitialized = true;
-
 
   // check environment variable 
@@ -154,6 +161,6 @@
     for(size_t i=0; i<numOfElm; ++i) {
       G4int Z = G4int(((*theElmTable)[i])->GetZ());
-      if(Z < 1) Z = 1;
-      else if(Z > 92) Z = 92;
+      if(Z < 1)         { Z = 1; }
+      else if(Z > maxZ) { Z = maxZ; }
       //G4cout << "Z= " << Z << G4endl;
       // Initialisation 
@@ -173,9 +180,9 @@
 			       const char* p)
 {
-  if(data[Z]) return;
+  if(data[Z]) { return; }
   const char* path = p;
   if(!p) {
-  // check environment variable 
-  // Build the complete string identifying the file with the data set
+    // check environment variable 
+    // Build the complete string identifying the file with the data set
     path = getenv("G4NEUTRONXSDATA");
     if (!path) {
@@ -215,6 +222,12 @@
     G4double sig1 = (*data[Z])[n];
     dynParticle->SetKineticEnergy(emax);
-    ggXsection->GetCrossSection(dynParticle, Elem);
-    G4double sig2 = ggXsection->GetElasticGlauberGribovXsc();
+    G4double sig2 = 0.0;
+    if(1 == Z) {
+      fNucleon->GetHadronNucleonXscPDG(dynParticle, proton);
+      sig2 = fNucleon->GetElasticHadronNucleonXsc();
+    } else {
+      ggXsection->GetCrossSection(dynParticle, Elem);
+      sig2 = ggXsection->GetElasticGlauberGribovXsc();
+    }
     if(sig2 > 0.) { coeff[Z] = sig1/sig2; } 
   } 
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticCrossSection.cc	(revision 1340)
@@ -30,4 +30,5 @@
 
 #include "G4NeutronInelasticCrossSection.hh"
+#include "G4HadTmpUtil.hh"
 #include "globals.hh"
 
@@ -44,10 +45,10 @@
     G4IsotopeVector* isoVector = anEle->GetIsotopeVector();
     G4double* abundVector = anEle->GetRelativeAbundanceVector();
-    G4double ZZ;
-    G4double AA;
+    G4int ZZ;
+    G4int AA;
 
     for (G4int i = 0; i < nIso; i++) {
-      ZZ = G4double( (*isoVector)[i]->GetZ() );
-      AA = G4double( (*isoVector)[i]->GetN() );
+      ZZ = (*isoVector)[i]->GetZ();
+      AA = (*isoVector)[i]->GetN();
       psig = GetCrossSection(KE, AA, ZZ);
       cross_section += psig*abundVector[i];
@@ -55,5 +56,7 @@
   
   } else {
-    cross_section = GetCrossSection(KE, anEle->GetN(), anEle->GetZ());
+    G4int ZZ = G4lrint(anEle->GetZ());
+    G4int AA = G4lrint(anEle->GetN());
+    cross_section = GetCrossSection(KE, AA, ZZ);
   }
 
@@ -63,9 +66,12 @@
    
 G4double G4NeutronInelasticCrossSection::
-GetCrossSection(G4double anEnergy, G4double atomicNumber, G4double nOfProtons)
+GetCrossSection(G4double anEnergy, G4int AA, G4int ZZ)
 {
+  G4double atomicNumber = G4double(AA);
+  G4double nOfProtons = G4double(ZZ);
+
   if (anEnergy > 19.9*GeV ) 
   { // constant cross section above ~20GeV.
-    return  GetCrossSection(19.8*GeV,atomicNumber,nOfProtons);
+    return  GetCrossSection(19.8*GeV, AA, ZZ);
   } 
   G4double kineticEnergy = std::log10(DBL_MIN/MeV);
Index: trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticXS.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticXS.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NeutronInelasticXS.cc	(revision 1340)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4NeutronInelasticXS.cc,v 1.4 2010/06/03 11:50:21 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-04-beta-01 $
+// $Id: G4NeutronInelasticXS.cc,v 1.6 2010/10/15 22:35:32 dennis Exp $
+// GEANT4 tag $Name: hadr-cross-V09-03-12 $
 //
 // -------------------------------------------------------------------
@@ -47,20 +47,26 @@
 #include "G4PhysicsVector.hh"
 #include "G4GlauberGribovCrossSection.hh"
+#include "G4HadronNucleonXsc.hh"
 #include "G4NistManager.hh"
+#include "G4Proton.hh"
 
 #include <iostream>
 #include <fstream>
 #include <sstream>
+
 using namespace std;
 
 G4NeutronInelasticXS::G4NeutronInelasticXS() 
-{
-  verboseLevel = 0;
-  G4cout  << "G4NeutronInelasticXS::G4NeutronInelasticXS: Initialise " << G4endl;
-  for(G4int i=0; i<93; ++i) {
-    data[i] = 0;
-    coeff[i]= 1.0;
-  }
+  : proton(G4Proton::Proton()), maxZ(92)
+{
+  //  verboseLevel = 0;
+  if(verboseLevel > 0){
+    G4cout  << "G4NeutronInelasticXS::G4NeutronInelasticXS Initialise for Z < " 
+	    << maxZ + 1 << G4endl;
+  }
+  data.resize(maxZ+1, 0);
+  coeff.resize(maxZ+1, 1.0);
   ggXsection = new G4GlauberGribovCrossSection();
+  fNucleon = new G4HadronNucleonXsc();
   isInitialized = false;
 }
@@ -68,5 +74,5 @@
 G4NeutronInelasticXS::~G4NeutronInelasticXS()
 {
-  for(G4int i=0; i<92; ++i) {
+  for(G4int i=0; i<=maxZ; ++i) {
     delete data[i];
   }
@@ -81,6 +87,6 @@
 
 G4bool 
-G4NeutronInelasticXS::IsZAApplicable(const G4DynamicParticle*,
-				     G4double /*ZZ*/, G4double /*AA*/)
+G4NeutronInelasticXS::IsIsoApplicable(const G4DynamicParticle*,
+				      G4int /*ZZ*/, G4int /*AA*/)
 {
   return false;
@@ -97,4 +103,5 @@
 
   G4int Z = G4int(elm->GetZ());
+  if(Z < 1 || Z > maxZ) { return xs; }
   G4PhysicsVector* pv = data[Z];
   //  G4cout  << "G4NeutronInelasticXS::GetCrossSection e= " << ekin << " Z= " << Z << G4endl;
@@ -104,9 +111,9 @@
     Initialise(Z);
     pv = data[Z];
-    if(!pv) return xs;
+    if(!pv) { return xs; }
   }
 
   G4double e1 = pv->Energy(0);
-  if(ekin <= e1) return xs;
+  if(ekin <= e1) { return xs; }
 
   G4int n = pv->GetVectorLength() - 1;
@@ -114,4 +121,7 @@
   if(ekin <= e2) { 
     xs = pv->Value(ekin); 
+  } else if(1 == Z) { 
+    fNucleon->GetHadronNucleonXscPDG(aParticle, proton);
+    xs = coeff[1]*fNucleon->GetInelasticHadronNucleonXsc();
   } else {          
     ggXsection->GetCrossSection(aParticle, elm);
@@ -119,5 +129,5 @@
   }
 
-  if(verboseLevel > 0){
+  if(verboseLevel > 0) {
     G4cout  << "ekin= " << ekin << ",  XSinel= " << xs << G4endl;
   }
@@ -129,12 +139,10 @@
 G4NeutronInelasticXS::BuildPhysicsTable(const G4ParticleDefinition& p)
 {
-  G4cout << "G4NeutronInelasticXS::BuildPhysicsTable: " << G4endl;
-  G4cout << p.GetParticleName() << G4endl;
-  if(p.GetParticleName() != "neutron") {
-    return;
-  }
-  if(isInitialized) return;
+  if(verboseLevel > 0){
+    G4cout << "G4NeutronInelasticXS::BuildPhysicsTable for " 
+	   << p.GetParticleName() << G4endl;
+  }
+  if(isInitialized || p.GetParticleName() != "neutron") { return; }
   isInitialized = true;
-
 
   // check environment variable 
@@ -154,6 +162,6 @@
     for(size_t i=0; i<numOfElm; ++i) {
       G4int Z = G4int(((*theElmTable)[i])->GetZ());
-      if(Z < 1) Z = 1;
-      else if(Z > 92) Z = 92;
+      if(Z < 1)         { Z = 1; }
+      else if(Z > maxZ) { Z = maxZ; }
       //G4cout << "Z= " << Z << G4endl;
       // Initialisation 
@@ -173,5 +181,5 @@
 				 const char* p)
 {
-  if(data[Z]) return;
+  if(data[Z]) { return; }
   const char* path = p;
   if(!p) {
@@ -215,6 +223,12 @@
     G4double sig1 = (*data[Z])[n];
     dynParticle->SetKineticEnergy(emax);
-    ggXsection->GetCrossSection(dynParticle, Elem);
-    G4double sig2 = ggXsection->GetInelasticGlauberGribovXsc();
+    G4double sig2 = 0.0;
+    if(1 == Z) {
+      fNucleon->GetHadronNucleonXscPDG(dynParticle, proton);
+      sig2 = fNucleon->GetInelasticHadronNucleonXsc();
+    } else {
+      ggXsection->GetCrossSection(dynParticle, Elem);
+      sig2 = ggXsection->GetInelasticGlauberGribovXsc();
+    }
     if(sig2 > 0.) { coeff[Z] = sig1/sig2; }
   } 
Index: trunk/source/processes/hadronic/cross_sections/src/G4NucleonNuclearCrossSection.cc
===================================================================
--- trunk/source/processes/hadronic/cross_sections/src/G4NucleonNuclearCrossSection.cc	(revision 1337)
+++ trunk/source/processes/hadronic/cross_sections/src/G4NucleonNuclearCrossSection.cc	(revision 1340)
@@ -38,4 +38,6 @@
 #include "G4Neutron.hh"
 #include "G4Proton.hh"
+#include "G4HadTmpUtil.hh"
+
 
 // Group 1: He, Be, C for 44 energies  
@@ -43,8 +45,9 @@
 const G4double G4NucleonNuclearCrossSection::e1[44] =     
 {
-  0.014, 0.015, 0.017, .02, 0.022, 0.025, 0.027, 0.03, 0.035, .04, 0.045, 0.05, .06, 0.07, 
-  .08, 0.09,  .1, .12, .14, .15, .16, .18, .20, .25, .30, .35, .4 , 0.5, 0.6, 0.7,  0.8,  
-  0.9,   1, 1.5,   2,   3,   5,  7, 10,   
-  20,   50,  100,  500, 1000
+  0.014, 0.015, 0.017, 0.02, 0.022, 0.025, 0.027, 0.03, 0.035, 0.04,
+  0.045, 0.05,  0.06,  0.07, 0.08,  0.09,  0.1,   0.12, 0.14,  0.15,
+  0.16,  0.18,  0.20,  0.25, 0.30,  0.35,  0.4,   0.5,  0.6,   0.7,
+  0.8,   0.9,   1.0,   1.5,  2.0,   3.0,   5.0,   7.0, 10.0,  20.0,
+ 50.0, 100.0, 500.0, 1000.0
 };
 
@@ -391,7 +394,9 @@
 const G4double G4NucleonNuclearCrossSection::e6[46] =      
 {
-  0.014, 0.015, 0.017, 0.019, .02, 0.022, 0.025, 0.027, 0.03, 0.035, .04, 0.045, 0.05, 
-  0.055, .06, 0.07, .08, 0.09, .1, .12, .14, .15, .16, .18, .20, .25, .30, .35, .4 , 
-  0.5, 0.6, 0.7,  0.8, 0.9, 1, 1.5, 2, 3, 5, 7, 10, 20, 50, 100, 500, 1000
+  0.014, 0.015, 0.017, 0.019, 0.02, 0.022, 0.025, 0.027, 0.03, 0.035,
+  0.04,  0.045, 0.05,  0.055, 0.06, 0.07,  0.08,  0.09,  0.1,  0.12,
+  0.14,  0.15,  0.16,  0.18,  0.20, 0.25,  0.30,  0.35,  0.4 , 0.5,
+  0.6,   0.7,   0.8,   0.9,   1.0,  1.5,   2.0,   3.0,   5.0,  7.0,
+ 10.0,  20.0,  50.0, 100.0, 500.0, 1000.0
 };
 
@@ -443,5 +448,5 @@
 using namespace std;
 
-//////////////////////////////////////////////////////////////////////////////////
+///////////////////////////////////////////////////////////////////////////////
 //
 //
@@ -535,6 +540,5 @@
 }
 
-///////////////////////////////////////////////////////////////////////////////////
-//
+///////////////////////////////////////////////////////////////////////////////
 //
 
@@ -547,52 +551,54 @@
 ////////////////////////////////////////////////////////////////////////////
 //
-//
 
 G4double G4NucleonNuclearCrossSection::
-GetCrossSection( const G4DynamicParticle* aParticle, 
-                 const G4Element* anElement,
-                       G4double                )
-
-{
-  return GetIsoZACrossSection(aParticle, anElement->GetZ(), anElement->GetN(), 0.);
+GetCrossSection(const G4DynamicParticle* aParticle, 
+                const G4Element* anElement, G4double)
+
+{
+  G4int Z = G4lrint(anElement->GetZ());
+  G4int A = G4lrint(anElement->GetN());
+  return GetZandACrossSection(aParticle, Z, A, 0.);
 }
 
 ////////////////////////////////////////////////////////////////////////////
 //
-//
-
-G4bool G4NucleonNuclearCrossSection::IsApplicable(const G4DynamicParticle* aParticle, 
+
+G4bool
+G4NucleonNuclearCrossSection::IsApplicable(const G4DynamicParticle* aParticle, 
 						  const G4Element* anElement)
 {
-  return IsZAApplicable(aParticle, anElement->GetZ(), anElement->GetN()); 
+  G4int Z = G4lrint(anElement->GetZ());
+  G4int A = G4lrint(anElement->GetN());
+  return IsIsoApplicable(aParticle, Z, A); 
 }
 
 ////////////////////////////////////////////////////////////////////////////
 //
-//
-
-G4bool G4NucleonNuclearCrossSection::IsZAApplicable(const G4DynamicParticle* aParticle, 
-						    G4double Z, G4double)
+
+G4bool
+G4NucleonNuclearCrossSection::IsIsoApplicable(const G4DynamicParticle* aParticle, 
+						    G4int Z, G4int)
 {
   G4bool result = false;
   if(aParticle->GetDefinition() == theNeutron ) result = true;
   if(aParticle->GetDefinition() == theProton)   result = true;
-  if(Z < 1.5)                                   result = false;
+  if(Z < 2)                                     result = false;
   if(aParticle->GetKineticEnergy() > 999.9*GeV) result = false;
   return result;
 }
 
+
 ////////////////////////////////////////////////////////////////////////////
 //
-//
 
 G4double G4NucleonNuclearCrossSection::
-GetIsoZACrossSection( const G4DynamicParticle* aParticle, 
-                      G4double  zElement, G4double, G4double  )
+GetZandACrossSection(const G4DynamicParticle* aParticle, 
+                     G4int zElement, G4int, G4double  )
 {
    G4double kineticEnergy = aParticle->GetKineticEnergy();
   
    G4double result = 0;
-   G4int Z = G4int(zElement + 0.5);
+   G4int Z = zElement;
 
    // G4cout<<"Z = "<<Z<<G4endl;
@@ -675,5 +681,4 @@
 
 /////////////////////////////////////////////////////////////////////////////
-//
 //
 
